<template>
  <div class="contSecc">
    <div class="titulo">
      <link
        rel="stylesheet"
        href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/css/bootstrap.min.css"
        integrity="sha384-9aIt2nRpC12Uk9gS9baDl411NQApFmC26EwAOH8WgZl5MYYxFfc+NcPb1dKGj7Sk"
        crossorigin="anonymous"
      />
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs" :large="false">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>Visualización de Asistencia</strong>
    </div>

    <div class="cotm">
      <div class="tmod">
        <strong>Visualización de Asistencia</strong>
      </div>
    </div>

    <div class="contSecc">
      <div class="titSecCard">Búsqueda</div>

      <v-card style="background-color: #fafafa">
        <v-container fluid>
          <div class="indicaciones">Selecciona los datos para La búsqueda</div>
          <v-row align="center" no-gutters>
            <v-col cols="5">
              <!-- Calendario inicio -->
              <div class="divCol spaceCol">
                <div class="col12">
                  <v-container grid-list-md>
                    <v-row justify="center">
                      <v-layout row wrap>
                        <v-menu
                          ref="menu2"
                          v-model="menu2"
                          :close-on-content-click="false"
                          :nudge-right="40"
                          transition="scale-transition"
                          offset-y
                          :cache-items="false"
                          max-width="290px"
                          min-width="290px"
                        >
                          <template v-slot:activator="{ on }">
                            <v-text-field
                              v-model="date"
                              prepend-icon="mdi-calendar-month"
                              label="Fecha Inicio"
                              v-on="on"
                              :cache-items="false"
                              autocomplete="off"
                            >
                            </v-text-field>
                          </template>
                          <v-date-picker
                            v-model="date"
                            no-title
                            :cache-items="false"
                            @input="menu2 = false"
                            @change="chgDate"
                          ></v-date-picker>
                        </v-menu>
                      </v-layout>
                    </v-row>
                  </v-container>
                </div>
              </div>
            </v-col>
            <v-col cols="5">
              <!-- Calendario fin-->
              <div class="divCol spaceCol">
                <div class="col12">
                  <v-container grid-list-md>
                    <v-row justify="center">
                      <v-layout row wrap>
                        <v-menu
                          ref="menu"
                          v-model="menu"
                          :nudge-right="40"
                          :close-on-content-click="false"
                          transition="scale-transition"
                          offset-y
                          :cache-items="false"
                          max-width="290px"
                          min-width="290px"
                        >
                          <!-- <template v-slot:activator="{ on, attrs }"> -->
                          <template v-slot:activator="{ on }">
                            <v-text-field
                              v-model="date1"
                              prepend-icon="mdi-calendar-month"
                              label="Fecha Fin"
                              readonly
                              v-on="on"
                              :cache-items="false"
                              autocomplete="off"
                            >
                            </v-text-field>
                          </template>
                          <v-date-picker
                            v-model="date1"
                            no-title
                            :cache-items="false"
                            @input="menu = false"
                            @change="chgDate"
                          >
                          </v-date-picker>
                        </v-menu>
                      </v-layout>
                    </v-row>
                  </v-container>
                </div>
              </div>
            </v-col>

            <!-- Boton Buscar -->
            <v-col cols="2" justify="center" align="center">
              <v-btn
                color="primary"
                dark
                @click="getReporte1()"
                :disabled="disabledBtnBuscar && ftFinishService"
                class="btnDisabled"
              >
                <strong style="fond-size: 16px; color: #000">Buscar</strong>
              </v-btn>
            </v-col>
          </v-row>
        </v-container>
      </v-card>
      <!--  termina parametrizado-->

      <div class="gris">
        <div class="contSecc">
          <FiltroTerritorioSupervisor
            :usuario="usr"
            :callbackFinishService="callbackFtFinishService"
            :callbackSelect="callbackFtSelect"
          />
          <div class="divBuscador">
            <div class="padding">
              <v-text-field
                v-model="search"
                class="buscador"
                append-icon="mdi-magnify"
                label="Buscar..."
                clearable
                single-line
                hide-details
              >
              </v-text-field>
            </div>
          </div>

          <!--  tabla-->
          <v-data-table
            :headers="encabezadoAsignacion"
            :items="asignaciones"
            :page.sync="page"
            :items-per-page="itemsPerPage"
            @page-count="pageCount = $event"
            :search="search"
            class="tblGeneral tblReporte"
          >
            <template v-slot:item.statusSalida_="{ item }">
              {{
                item.statusSalida == "Salida a Tiempo"
                  ? item.statusSalida
                  : "Fuera de Tiempo"
              }}
            </template>
          </v-data-table>
          <!-- termina  tabla-->
        </div>
      </div>

      <div style="margin: 25px 10px 50px 10px">
        <v-btn
          color="primary"
          dark
          @click="downExcel()"
          :disabled="disabledBtnDownload"
          class="btnDisabled"
        >
          <strong style="fond-size: 16px; color: #000">Descargar a Excel</strong>
        </v-btn>
      </div>

      <!-- Dialog dialogFechasNulas  -->
      <v-dialog v-model="dialogFechasNulas" max-width="600" persistent>
        <v-card class="padding">
          <v-card-title class="headline">
            <div class="titModal">
              <div><strong>No se cargo Informacion</strong></div>
            </div>
          </v-card-title>
          <div class="contModal tCenter">
            <div>Te Falta llenar Datos De busqueda</div>
          </div>
          <div class="btnCenter">
            <v-btn color="primary" dark @click="dialogFechasNulas = false">
              <strong style="fond-size: 16px; color: #000">¡De acuerdo!</strong>
            </v-btn>
          </div>
        </v-card>
      </v-dialog>
    </div>

    <v-dialog v-model="dlgMensaje" persistent max-width="600px">
      <v-card>
        <div class="gris">
          <v-card-title class="headline">
            <div class="titModal">
              <div>
                <strong> {{ titMensaje }}</strong>
              </div>
            </div>
          </v-card-title>
          <div class="contModal tCenter">
            <strong> {{ txtMensaje }}</strong>
          </div>
          <br />
          <div class="tCenter">
            <v-btn color="primary" dark @click="dlgMensaje = false">
              <strong style="fond-size: 16px; color: #000">OK</strong>
            </v-btn>
          </div>
        </div>
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
import FileSaver from "file-saver";
import axios from "axios";
import store from "@/store";
const localStorage = store.state.serviceLocalStorage;
import moment from "moment";

import FiltroTerritorioSupervisor from "./componentes/FiltroTerritorioSupervisor.vue";
export default {
  components: { FiltroTerritorioSupervisor },
  name:
    "supervision_mantenimiento_asignaciones_reportes_asistencia_mantenimiento_supervisor",

  data() {
    return {
      usr: null,
      usr2: 0,
      filtroActivo: 0,
      filtroPasivo: [],
      ftFinishService: false,
      //calendario
      menu: false,
      modal: false,
      menu1: false,
      menu2: false,
      date: "",
      date1: "",
      dateFormatted: "",
      dateFormatted2: "",
      //dialogs
      dialogFechasNulas: false,
      disabledBtnBuscar: true,
      disabledBtnDownload: true,
      //   DIALOGS
      dlgMensaje: false,
      titMensaje: "",
      txtMensaje: "",

      //pagina
      pageCount: 1,
      page: 1,
      itemsPerPage: 20,
      search: "",
      propiedades_footer: {
        itemsPerPageOptions: [2, 4, 5, 10],
        //habilita botones
        habilitaFechaFin: true,
      },
      encabezadoAsignacion: [
        {
          text: "No.Usuario",
          value: "idUsuario",
          align: "center",
        },
        {
          text: "Nombre",
          value: "nombreUsuario",
          align: "center",
        },
        {
          text: "Fecha",
          value: "fecha",
          align: "center",
        },
        {
          text: "Semana",
          value: "semana",
          align: "center",
        },
        {
          text: "Dia",
          value: "dia",
          align: "center",
        },
        {
          text: "Hora Entrada",
          value: "horaEntrada",
          align: "center",
        },
        {
          text: "Hora Salida",
          value: "horaSalida",
          align: "center",
        },
        {
          text: "Horas Trabajadas",
          value: "horasTrabajadas",
          align: "center",
        },
        {
          // text: "Supervisiones Realizadas",
          text: "Tareas Realizadas",
          value: "totalVisitas",
          align: "center",
        },
        {
          //text: "Tareas Realizadas",
          text: "Módulos Contestados",
          value: "totalModulos",
          align: "center",
        },
        {
          text: "Estatus Entrada",
          value: "statusEntrada",
          align: "center",
        },
        {
          text: "Estatus Salida",
          value: "statusSalida_",
          align: "center",
        },
      ],
      asignaciones: [],
      asignacionesReslpaldo: [],
      metadata: {
        usuarios: [],
      },
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home",
          },
        },
        {
          text: "Supervisión Mantenimiento",
          disabled: false,
          exact: true,
          to: {
            name: "supervision_mantenimiento_asignaciones_home",
          },
        },
        {
          text: "Visualización de Asistencia",
          disabled: true,
        },
      ],
    };
  },
  created() {
    this.usr2 = localStorage.userToken().empleado;
    // this.getReporte1();
    this.limpiaFormulario();
  },
  methods: {
    verifDates() {
      const [yrI, mesI, diaI] = this.date.split("-");
      const [yrF, mesF, diaF] = this.date1.split("-");

      var dtIni = new Date(yrI, mesI - 1, diaI);
      var dtFin = new Date(yrF, mesF - 1, diaF);
      var hoy = new Date();

      //console.log("Fecha hoy:" + hoy )
      //console.log("Fecha Ini:" + dtIni )
      //console.log("Fecha Fin:" + dtFin )

      if (dtFin < dtIni) {
        this.alerta(
          "Error en Fechas",
          "La fecha fin no puede ser menor a la fecha de inicio"
        );
        return false;
      }

      if (dtFin > hoy) {
        console.log("huich");
        this.alerta(
          "Error en Fecha",
          "La fecha fin no puede ser mayor a la fecha actual"
        );
        return false;
      }

      // Fechas OK
      return true;
    },
    getReporte1() {
      if (this.verifDates()) {
        this.objAdd = {
          fechaInicio: moment(String(this.date)).format("DDMMYY"), //"010121",
          fechaFin: moment(String(this.date1)).format("DDMMYY"), //"280221",
          idUsuario: null,
          zona: null,
          // fechaProgramada: moment(String(this.dateFormatted)).format('YYYYMMDD'),
        };
        //console.log(JSON.stringify(this.objAdd));

        axios
          //servicio viejo /asignacion-mtto/secure/post/obtieneAsignacionesSupMtto"
          .post(
            "/asignacion-mtto/secure/post/obtieneReporteAsistenciaMtto",
            //ES EL STATUS DE LAS ASIGNACIONES
            this.objAdd
          )
          .then((response) => {
            if (response) {
              if (response.status === 200) {
                this.asignaciones = response.data.data;
                this.asignacionesReslpaldo = response.data.data;
                console.log(response.data.data);
                this.filtrarRespuesta();
              } else {
                this.dialogFechasNulas = true;
              }
            }
          })
          .catch((error) => {
            console.log(error);
          })
          .finally(function () {});
      }
    },

    downExcel() {
      const dataFinal = this.crearInfoExcel(this.asignaciones);
      axios({
        method: "post",
        url: "/json/convert/secure/array/excel",
        responseType: "blob",
        data: dataFinal,
      })
        .then((response) => {
          //console.log("La data:" + response.data)

          if (response.headers["content-type"] !== "application/json") {
            FileSaver.saveAs(response.data, response.headers["file-name"]);
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function () {});
    },
    crearInfoExcel(data) {
      let datos = data;

      let xlsInfo = [];
      let fields = [
        //  0-Header Excel    1-Dato desde DB
        ["NO_EMPLEADO", "idUsuario"],
        ["NOMBRE_EMPLEADO", "nombreUsuario"],
        ["LAT_LOG_ENTRADA", "latitudEntrada", "longitudEntrada"],
        ["LAT_LOG_SALIDA", "latitudSalida", "longitudSalida"],
        ["FECHA", "fecha"],
        ["DIA", "dia"],
        ["FECHA_INICIO", "fechaInicio"],
        ["FECHA_FIN", "fechaFin"],
        ["HORA_ENTRADA", "horaEntrada"],
        ["HORA_SALIDA", "horaSalida"],
        ["ESTADO_ENTRADA", "statusEntrada"],
        ["ESTADO_SAIDA", "statusSalida"],
        ["LUGAR_ENTRADA", "lugarEntrada"],
        ["LUGAR_SALIDA", "lugarSalida"],
        ["SEMANA", "semana"],
        ["HORAS_TRABAJADAS", "horasTrabajadas"],
      ];
      for (var i = 0; i < data.length; i++) {
        let ass = new Object();
        for (var j = 0; j < fields.length; j++) {
          if (j == 2 || j == 3) {
            let latitud = eval(
              "typeof(datos[i]." +
                fields[j][1] +
                ") == 'undefined' ? '0' :  datos[i]." +
                fields[j][1]
            );
            let longitud = eval(
              "typeof(datos[i]." +
                fields[j][2] +
                ") == 'undefined' ? '0' :  datos[i]." +
                fields[j][2]
            );
            let coordenadas = latitud + "," + longitud;
            eval("ass." + fields[j][0] + "= coordenadas");
          } else {
            //ass.fields[j][0]  = typeof(datos[i].fields[j][1] ) == 'undefined' ? '' : + datos[i].fields[j][1];
            let instruccion =
              "ass." +
              fields[j][0] +
              " = typeof(datos[i]." +
              fields[j][1] +
              " ) == 'undefined' ? '' :  datos[i]." +
              fields[j][1];
            eval(instruccion);
          }
        }
        xlsInfo.push(ass);
      }
      return xlsInfo;
    },
    limpiaFormulario() {
      //this.date = "";
      //this.date1 = "";
      //this.menu2 = "";
      //this.menu = "";
      this.usuarioEncontrado = "";
      this.cecoSeleccionado = "";
      this.listaTipoNego = "";
      this.metadata.cecos = [];
      this.metadata.negocios = [];
      this.metadata.usuarios = [];
      this.metadata.gerentes = [];
      this.dateFormatted = "";
      this.picker = "";
      this.comentario = "";
      this.dialogConfimacionActualiza = false;
    },
    formatDate(date) {
      if (!date) return null;

      const [year, month, day] = date.split("-");
      return `${month}/${day}/${year}`;
    },
    parseDate(date) {
      if (!date) return null;

      const [month, day, year] = date.split("/");
      return `${year}-${month.padStart(2, "0")}-${day.padStart(2, "0")}`;
    },
    chgDate() {
      if (this.date.length > 8 && this.date1.length > 8) this.disabledBtnBuscar = false;
    },
    alerta(titulo, mensaje) {
      this.titMensaje = titulo;
      this.txtMensaje = mensaje;
      this.dlgMensaje = true;
    },
    getColor(status) {
      return status == "Salida a Tiempo" ? "rojo" : "verde";
    },

    callbackFtFinishService(filtroPasivo) {
      console.log("callbackFtFinishService==>" + JSON.stringify(filtroPasivo));
      this.filtroPasivo = filtroPasivo;
      this.ftFinishService = true;
    },
    callbackFtSelect(event) {
      console.log("callbackFtSelect==>" + JSON.stringify(event));
      this.filtroActivo = event.idTerritorio;
      this.filtrarRespuesta();
    },
    filtrarRespuesta() {
      if (this.asignacionesReslpaldo) {
        this.limpiaFormulario();
        this.disabledBtnDownload = false;
        this.disabledBtnBuscar = true;
        this.asignaciones = this.asignacionesReslpaldo;

        if (this.filtroPasivo.length > 0) {
          this.asignaciones = this.asignacionesReslpaldo.filter(
            (item) =>
              this.filtroPasivo.find(
                (itemPasivo) => itemPasivo.idTerritorio == item.idTerritorio
              ) && item.idUsuario == this.usr2
          );
        }
        if (this.filtroActivo != 0) {
          this.asignaciones = this.asignaciones.filter(
            (item) => item.idTerritorio == this.filtroActivo
          );
        }
      }
    },
  }, // fin metodos
  computed: {
    computedDateFormatted() {
      return this.formatDate(this.date);
    },
  },
  watch: {
    date(val) {
      this.dateFormatted = this.formatDate(this.date);
    },
    date2(val) {
      this.dateFormatted2 = this.formatDate(this.date);
    },
  },
};
</script>

<style>
.padding {
  padding-bottom: 25px;
}
.btnDisabled {
  color: gray;
  border: 1px solid #f7b851;
}
</style>
